groovy.json.internal

## Class CharScanner

- java.lang.Object
- - groovy.json.internal.CharScanner

    public class CharScanner
    extends java.lang.Object

Author:
  Richard Hightower

### Field Summary

Fields
`protected static int` `ALPHA_0`
`protected static int` `ALPHA_1`
`protected static int` `ALPHA_2`
`protected static int` `ALPHA_3`
`protected static int` `ALPHA_4`
`protected static int` `ALPHA_5`
`protected static int` `ALPHA_6`
`protected static int` `ALPHA_7`
`protected static int` `ALPHA_8`
`protected static int` `ALPHA_9`
`protected static int` `CLOSED_BRACKET`
`protected static int` `CLOSED_CURLY`
`protected static int` `COMMA`
`protected static int` `DECIMAL_POINT`
`protected static int` `DOUBLE_QUOTE`
`protected static int` `ESCAPE`
`protected static int` `LETTER_BIG_E`
`protected static int` `LETTER_E`
`protected static int` `MINUS`
`protected static int` `PLUS`

### Constructor Summary

Constructors
Constructor and Description
`CharScanner()`

### Method Summary

All Methods Static Methods Concrete Methods
`static char[][]` `compact(char[][] array)`
`static java.lang.String` `debugCharDescription(int c)`
`static java.lang.String` `errorDetails(java.lang.String message, char[] array, int index, int ch)`
`static boolean` `hasDecimalChar(char[] chars, boolean negative)`
`static boolean` `isDecimalChar(int currentChar)`
`static boolean` `isDecimalDigit(int c)`
`protected static boolean` `isDelimiter(int c)`
`static boolean` `isDigit(int c)`
`static boolean` `isDigits(char[] inputArray)`
`static boolean` `isInteger(char[] digitChars)`
`static boolean` `isInteger(char[] digitChars, int offset, int len)`
`static boolean` `isLong(char[] digitChars)`
`static boolean` `isLong(char[] digitChars, int offset, int len)`
`static boolean` `isNumberDigit(int c)`
`static java.math.BigDecimal` `parseBigDecimal(char[] buffer)`
`static java.math.BigDecimal` `parseBigDecimal(char[] buffer, int from, int to)`
`static double` `parseDouble(char[] buffer)`
`static double` `parseDouble(char[] buffer, int from, int to)`
`static float` `parseFloat(char[] buffer, int from, int to)`
`static int` `parseInt(char[] digitChars)`
`static int` `parseIntFromTo(char[] digitChars, int offset, int to)`
`static int` `parseIntFromToIgnoreDot(char[] digitChars, int offset, int to)`
`static java.lang.Number` `parseJsonNumber(char[] buffer)`
`static java.lang.Number` `parseJsonNumber(char[] buffer, int from, int to)`
`static java.lang.Number` `parseJsonNumber(char[] buffer, int from, int max, int[] size)`
`static long` `parseLong(char[] digitChars)`
`static long` `parseLongFromTo(char[] digitChars, int offset, int to)`
`static long` `parseLongFromToIgnoreDot(char[] digitChars, int offset, int to)`
`static char[]` `readNumber(char[] array, int idx)`
`static char[]` `readNumber(char[] array, int idx, int len)`
`static int` `skipWhiteSpace(char[] array, int index)`
`static int` `skipWhiteSpace(char[] array, int index, int length)`
`static int` `skipWhiteSpaceFast(char[] array)`
`static int` `skipWhiteSpaceFast(char[] array, int index)`
`static char[][]` `split(char[] inputArray, char split)`
`static char[][]` `splitByChars(char[] inputArray, char... delims)`
`static char[][]` `splitByCharsFromToDelims(char[] inputArray, int from, int to, char... delims)`
`static char[][]` `splitByCharsNoneEmpty(char[] inputArray, char... delims)`
`static char[][]` `splitByCharsNoneEmpty(char[] inputArray, int from, int to, char... delims)`
`static char[][]` `splitExact(char[] inputArray, char split, int resultsArrayLength)`
`static char[][]` `splitExact(char[] inputArray, int resultsArrayLength, char... delims)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### COMMA

    protected static final int COMMA

See Also:
  Constant Field Values

#### CLOSED_CURLY

    protected static final int CLOSED_CURLY

See Also:
  Constant Field Values

#### CLOSED_BRACKET

    protected static final int CLOSED_BRACKET

See Also:
  Constant Field Values

#### LETTER_E

    protected static final int LETTER_E

See Also:
  Constant Field Values

#### LETTER_BIG_E

    protected static final int LETTER_BIG_E

See Also:
  Constant Field Values

#### DECIMAL_POINT

    protected static final int DECIMAL_POINT

See Also:
  Constant Field Values

#### ALPHA_0

    protected static final int ALPHA_0

See Also:
  Constant Field Values

#### ALPHA_1

    protected static final int ALPHA_1

See Also:
  Constant Field Values

#### ALPHA_2

    protected static final int ALPHA_2

See Also:
  Constant Field Values

#### ALPHA_3

    protected static final int ALPHA_3

See Also:
  Constant Field Values

#### ALPHA_4

    protected static final int ALPHA_4

See Also:
  Constant Field Values

#### ALPHA_5

    protected static final int ALPHA_5

See Also:
  Constant Field Values

#### ALPHA_6

    protected static final int ALPHA_6

See Also:
  Constant Field Values

#### ALPHA_7

    protected static final int ALPHA_7

See Also:
  Constant Field Values

#### ALPHA_8

    protected static final int ALPHA_8

See Also:
  Constant Field Values

#### ALPHA_9

    protected static final int ALPHA_9

See Also:
  Constant Field Values

#### MINUS

    protected static final int MINUS

See Also:
  Constant Field Values

#### PLUS

    protected static final int PLUS

See Also:
  Constant Field Values

#### DOUBLE_QUOTE

    protected static final int DOUBLE_QUOTE

See Also:
  Constant Field Values

#### ESCAPE

    protected static final int ESCAPE

See Also:
  Constant Field Values

### Constructor Detail

#### CharScanner

    public CharScanner()

### Method Detail

#### isDigit

    public static boolean isDigit(int c)

#### isDecimalDigit

    public static boolean isDecimalDigit(int c)

#### isDecimalChar

    public static boolean isDecimalChar(int currentChar)

#### hasDecimalChar

    public static boolean hasDecimalChar(char[] chars,
                                         boolean negative)

#### isDigits

    public static boolean isDigits(char[] inputArray)

#### splitExact

    public static char[][] splitExact(char[] inputArray,
                                      char split,
                                      int resultsArrayLength)

#### splitExact

    public static char[][] splitExact(char[] inputArray,
                                      int resultsArrayLength,
                                      char... delims)

#### split

    public static char[][] split(char[] inputArray,
                                 char split)

#### splitByChars

    public static char[][] splitByChars(char[] inputArray,
                                        char... delims)

#### splitByCharsFromToDelims

    public static char[][] splitByCharsFromToDelims(char[] inputArray,
                                                    int from,
                                                    int to,
                                                    char... delims)

#### splitByCharsNoneEmpty

    public static char[][] splitByCharsNoneEmpty(char[] inputArray,
                                                 char... delims)

#### splitByCharsNoneEmpty

    public static char[][] splitByCharsNoneEmpty(char[] inputArray,
                                                 int from,
                                                 int to,
                                                 char... delims)

#### compact

    public static char[][] compact(char[][] array)

#### isLong

    public static boolean isLong(char[] digitChars)

#### isLong

    public static boolean isLong(char[] digitChars,
                                 int offset,
                                 int len)

#### isInteger

    public static boolean isInteger(char[] digitChars)

#### isInteger

    public static boolean isInteger(char[] digitChars,
                                    int offset,
                                    int len)

#### parseInt

    public static int parseInt(char[] digitChars)

#### parseIntFromTo

    public static int parseIntFromTo(char[] digitChars,
                                     int offset,
                                     int to)

#### parseIntFromToIgnoreDot

    public static int parseIntFromToIgnoreDot(char[] digitChars,
                                              int offset,
                                              int to)

#### parseLongFromToIgnoreDot

    public static long parseLongFromToIgnoreDot(char[] digitChars,
                                                int offset,
                                                int to)

#### parseLongFromTo

    public static long parseLongFromTo(char[] digitChars,
                                       int offset,
                                       int to)

#### parseLong

    public static long parseLong(char[] digitChars)

#### parseJsonNumber

    public static java.lang.Number parseJsonNumber(char[] buffer)

#### parseJsonNumber

    public static java.lang.Number parseJsonNumber(char[] buffer,
                                                   int from,
                                                   int to)

#### isNumberDigit

    public static final boolean isNumberDigit(int c)

#### isDelimiter

    protected static boolean isDelimiter(int c)

#### parseJsonNumber

    public static java.lang.Number parseJsonNumber(char[] buffer,
                                                   int from,
                                                   int max,
                                                   int[] size)

#### parseBigDecimal

    public static java.math.BigDecimal parseBigDecimal(char[] buffer)

#### parseBigDecimal

    public static java.math.BigDecimal parseBigDecimal(char[] buffer,
                                                       int from,
                                                       int to)

#### parseFloat

    public static float parseFloat(char[] buffer,
                                   int from,
                                   int to)

#### parseDouble

    public static double parseDouble(char[] buffer)

#### parseDouble

    public static double parseDouble(char[] buffer,
                                     int from,
                                     int to)

#### skipWhiteSpace

    public static int skipWhiteSpace(char[] array,
                                     int index)

#### skipWhiteSpace

    public static int skipWhiteSpace(char[] array,
                                     int index,
                                     int length)

#### readNumber

    public static char[] readNumber(char[] array,
                                    int idx)

#### readNumber

    public static char[] readNumber(char[] array,
                                    int idx,
                                    int len)

#### skipWhiteSpaceFast

    public static int skipWhiteSpaceFast(char[] array)

#### skipWhiteSpaceFast

    public static int skipWhiteSpaceFast(char[] array,
                                         int index)

#### errorDetails

    public static java.lang.String errorDetails(java.lang.String message,
                                                char[] array,
                                                int index,
                                                int ch)

#### debugCharDescription

    public static java.lang.String debugCharDescription(int c)